// cl /EHsc ebmExtract.cpp
#include <windows.h>
#include <Shlwapi.h>
#include <shlobj.h>
#include <zlib.h>

#include <cstdio>
#include <vector>
#include <string>

using namespace std;

#pragma comment(lib, "user32.lib")
#pragma comment(lib, "ole32.lib")
#pragma comment(lib, "Shlwapi.lib")
#pragma comment(lib, "Shell32.lib")
#pragma comment(lib, "zlib.lib")



// WJC
BOOL _ebmExtract(HANDLE hSrc, HANDLE hDst)
{
	char inBuf[128], outBuf[1024];

	z_stream z;
	z.zalloc = Z_NULL;
	z.zfree = Z_NULL;
	z.opaque = Z_NULL;

	z.next_in = Z_NULL;
	z.avail_in = 0;

	if (inflateInit(&z) != Z_OK)
	{
		printf(" -> Failed Zlib initialize: %s\n", z.msg);
		return FALSE;
	}

	z.next_out = (Bytef *)outBuf;
	z.avail_out = 1024;
	int stat = Z_OK;

	while (stat != Z_STREAM_END)
	{
		if (z.avail_in == 0)
		{
			DWORD dwReadSize;

			z.next_in = (Bytef *)inBuf;
			ReadFile(hSrc, inBuf, 128, &dwReadSize, NULL);
			z.avail_in = (int)dwReadSize;
		}

		stat = inflate(&z, Z_NO_FLUSH);
		if (stat == Z_STREAM_END)
			break;
		if (stat != Z_OK)
		{
			printf(" -> Failze Zlib inflate: %s", z.msg);
			return FALSE;
		}

		if (z.avail_out == 0)
		{
			DWORD dwWritten;
			WriteFile(hDst, outBuf, 1024, &dwWritten, NULL);
				
			z.next_out = (Bytef *)outBuf;
			z.avail_out = 1024;
		}
	}

	int cout = 1024 - z.avail_out;
	if (cout != 0)
	{
		DWORD dwWritten;
		WriteFile(hDst, outBuf, cout, &dwWritten, NULL);
	}

	if (inflateEnd(&z) != Z_OK)
	{
		printf(" -> Failed Zlib finalize: %s\n", z.msg);
		return FALSE;
	}

	return TRUE;
}


void main()
{
	char Buffer[MAX_PATH];

	CoInitialize(NULL);

	// _tmpEmblemfBNg̎w
	BROWSEINFO bi;
	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = Buffer;
	bi.lpszTitle = "_tmpEmblemfBNg̎w";
	bi.ulFlags = BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE|BIF_NONEWFOLDERBUTTON;
	bi.lpfn = NULL;
	bi.lParam = NULL;
	bi.iImage = NULL;

	LPITEMIDLIST lpil = SHBrowseForFolder(&bi);
	if (lpil)
		SHGetPathFromIDList(lpil, Buffer);
	else
		return;


	// t@CXg擾
	string strBasePath = Buffer;
	vector<string> vList;

	WIN32_FIND_DATA	fidt;
	HANDLE hHandle = FindFirstFile((strBasePath + "\\*.ebm").c_str(), &fidt);
	if (hHandle == INVALID_HANDLE_VALUE)
	{
		MessageBox(NULL, "t@CXg̎擾Ɏs܂B߂ȂB", "ERROR", MB_OK);
		return;
	}

	do {
		if (fidt.dwFileAttributes != FILE_ATTRIBUTE_DIRECTORY)
			vList.push_back(strBasePath + "\\" + fidt.cFileName);
	} while (FindNextFile(hHandle, &fidt));

	CloseHandle(hHandle);


	// WJfBNg̎w
	char BasePath[MAX_PATH];

	//BROWSEINFO bi;
	bi.hwndOwner = NULL;
	bi.pidlRoot = NULL;
	bi.pszDisplayName = BasePath;
	bi.lpszTitle = "WJfBNg̎w";
	bi.ulFlags = BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE;
	bi.lpfn = NULL;
	bi.lParam = NULL;
	bi.iImage = NULL;

	//LPITEMIDLIST lpil = SHBrowseForFolder(&bi);
	lpil = SHBrowseForFolder(&bi);
	if (lpil)
		SHGetPathFromIDList(lpil, BasePath);
	else
		return;


	// WJ
	char SrcFile[MAX_PATH], DestFile[MAX_PATH];
	HANDLE hSrcFile = NULL, hDstFile = NULL;
	int totalCount = 0, failedCountW = 0, failedCountR = 0;

	for (vector<string>::const_iterator it = vList.begin(); it != vList.end(); it++)
	{
		lstrcpy(SrcFile, (*it).c_str());
		printf("%s\n", SrcFile);
		PathCombine(DestFile, BasePath, PathFindFileName(SrcFile));

		hSrcFile = CreateFile(SrcFile, GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_READONLY, NULL);
		if (hSrcFile == NULL)
		{
			puts(" -> ǂݍ߂܂łB");
			failedCountR++;
			continue;
		}

		PathRenameExtension(DestFile, ".bmp");

		hDstFile = CreateFile(DestFile, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hDstFile == NULL)
		{
			puts(" -> ߂܂łB");
			failedCountW++;

			CloseHandle(hSrcFile);
			continue;
		}

		if (_ebmExtract(hSrcFile, hDstFile))
		{
			printf(" -> %s\n", DestFile);
			totalCount++;
		}

		CloseHandle(hSrcFile);
		CloseHandle(hDstFile);

	}

	wsprintf(Buffer, "succeeded: %d\nread failed: %d\nwrite failed: %d", totalCount, failedCountR, failedCountW);
	MessageBox(NULL, Buffer, "Info", MB_OK);

	CoUninitialize();
	return;
}
